classdef HandleFunction < Function
    
    properties(Access = private)
        handle
    end
    
    methods
        function obj = HandleFunction(fhandle)
           if ~isa(fhandle, 'function_handle')
              error('The argument must be a function handle.'); 
           end
           
           obj.handle = fhandle;
        end
        
        function y = of(obj, x)
           if ~isscalar(x)
               error('The argument must be a scalar.'); 
           end
           
           y = obj.handle(x);
        end
    end
    
end

